unit Unit1; 
{$mode objfpc}{$H+}
interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls,baseUnix,Unix;  // Add baseUnix,Unix
const
    BLOCK_SIZE: Word    = 4096;
    GPIO_BASE: LongWord = $20200;// Raspi GPIO $20200000/4096 = $20200

//  port name  addr    r/w  reset
    GPSFSEL0 = $00; // r/w  0
    GPSFSEL1 = $04; // r/w  0
    GPSFSEL2 = $08; // r/w  0
    GPSFSEL3 = $0C; // r/w  0
    GPSFSEL4 = $10; // r/w  0
    GPSFSEL5 = $14; // r/w  0
    // reserve $18
    GPSET0   = $1C; //   w  0
    GPSET1   = $20; //   w  0
    // reserve $24
    GPCLR0   = $28; //   w  0
    GPCLR1   = $2C; //   w  0
    // reserve $30
    GPLEV0   = $34; //   r  0

type
  { TForm1 }
  TForm1 = class(TForm)
    PortRead: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    procedure FormClose(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PortReadClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
      mem_fd:    Integer;
      gpio_map:  Pointer;
end;

var
  Form1: TForm1; 
implementation
{$R *.lfm}
{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
begin
  mem_fd:=0;
  mem_fd := fpopen('/dev/mem', O_RDWR );
  if mem_fd = -1 then
     begin
       Memo1.Lines.Add('Error at fpOpen, Check Root Permission ');
       Exit;
      end
  else
      begin
        Memo1.Lines.Add('fpOpen succeed, map address = '+ IntToHex(mem_fd,2));
        gpio_map := FpMmap( nil, BLOCK_SIZE, PROT_READ or PROT_WRITE, MAP_SHARED,mem_fd, GPIO_BASE) ;
        Memo1.Lines.Add('fpmmap succeed,address= '+ IntToHex(DWORD(gpio_map),8));
      end;
end;

procedure TForm1.FormClose(Sender: TObject);
begin
  fpMunmap(gpio_map,BLOCK_SIZE);
  fpClose(mem_fd);
end;

procedure TForm1.PortReadClick(Sender: TObject);
var
  value,setval:DWORD;
begin
  //port 9-0    999888777666555444333222111000   p9,p8,p7,p4,p3,p2       set to 000:input
     setval:=%11000000000111111000000000111111;
     value:= (PDWORD(gpio_map+GPSFSEL0))^; // Read GPSFSEL0
     setval:=setval and value;
     (PDWORD(gpio_map+GPSFSEL0))^:=setval;        // Set to input

  //port 19-10  999888777666555444333222111000   p18,p17,p15,p14,p11,p10 set to 000:input
     setval:=%11111000000111000000111111000000;
     value:= (PDWORD(gpio_map+GPSFSEL1))^;         // Read GPSFSEL1
     setval:=setval and value;
     (PDWORD(gpio_map+GPSFSEL1))^:=setval;        // Set to input

  //port 29-20  999888777666555444333222111000   p25,p24,p23,p22,p21     set to 000:input
     setval:=%11111111111111000000000000000111;
     value:= (PDWORD(gpio_map+GPSFSEL2))^;         // Read GPSFSEL2
     setval:=setval and value;
     (PDWORD(gpio_map+GPSFSEL2))^:=setval;
                                                  // Set to input
  value:= (PDWORD(gpio_map+GPLEV0))^;             // Read port
  Memo1.Lines.Add('GPLEV0=' + IntToHex(value,8)); // Read data display
end;
end.
